function[L,U] = lud(A)
% Computes the LU factorization on a square, invertible matrix a.

[m,n] = size(A);
assert(m == n);

L = eye(n);
U = A;

for k = 1:(n-1)

  % record row operations
  L(k+1:n, k) = U(k+1:n,k)./U(k,k);
  
  % perform row operations
  U(k+1:n,:) = U(k+1:n,:) - L(k+1:n,k)*U(k,:);

end
